from functools import wraps


def recurse_counter(func):
    @wraps(func)
    def recursor(self, *a, count=1, result=None, **kw):
        if result is None:
            result = []
        if count > 0:
            for intermediate in func(self, result, *a, count=count, **kw):
                recursor(self, *intermediate, count=count-1, result=result,
                         **kw)
        return result
    return recursor

__all__ = ['recurse_counter']
